
%%VertexPublicCode%%
layout(location=14) in uvec4 attWeightId;
layout(location=15) in vec4 attWeightValue;

uniform mat4 u_BoneTransforms[128];

vec3 transform_normal(vec3 normal)
{
	return (u_BoneTransforms[attWeightId[0]]*vec4(normal, 0)).xyz*attWeightValue[0]
		+  (u_BoneTransforms[attWeightId[1]]*vec4(normal, 0)).xyz*attWeightValue[1]
		+  (u_BoneTransforms[attWeightId[2]]*vec4(normal, 0)).xyz*attWeightValue[2]
		+  (u_BoneTransforms[attWeightId[3]]*vec4(normal, 0)).xyz*attWeightValue[3];
}


%%VertexMainCode%%
	vertex_position=u_BoneTransforms[attWeightId[0]]*vec4(a_position, 1)*attWeightValue[0]
				+	u_BoneTransforms[attWeightId[1]]*vec4(a_position, 1)*attWeightValue[1]
				+	u_BoneTransforms[attWeightId[2]]*vec4(a_position, 1)*attWeightValue[2]
				+	u_BoneTransforms[attWeightId[3]]*vec4(a_position, 1)*attWeightValue[3];

	vertex_normal = transform_normal(vertex_normal);

%%FragmentPublicCode%%
%%FragmentMainCode%%
